// 云函数入口文件
const cloud = require('wx-server-sdk')

cloud.init()
const db = cloud.database();
// 云函数入口函数
exports.main = async (event, context) => {
  switch (event.action) {
    case 'addOrder': {
      return addOrder(event)
    }
    case 'updateOrder': {
      return updateOrder(event)
    }
    case 'findAllOrderList':{
      return findAllOrderList(event)
    }
    case 'findOrderDetail':{
      return findOrder(event)
    }
    default: {
      return
    }
  }

}

async function addOrder(event){
  const wxContext = cloud.getWXContext()
  const  OPENID= wxContext.OPENID;
  const orderNo = await createOrderNo();
  // 添加订单
  /**
   * 将食品添加到订单中，更新order表
   */
  const result = await db.collection('order').add({
    data:{
      _openid:OPENID,
      orderNo,
      order_amount: event.order_amount,
      order_state:0, // 0 表示未完成 1表示已完成 2表示已取消
      pay_mode:1, // 默认微信支付
      pay_state:0, // 0待付款 1、已付款
      phone:event.phone,
      remark:event.remark,
      take_food_time:event.
    }
  })
}
/**
 * 生产订单编号
 */
async function createOrderNo(){
 //1、获取数据库中所有订单的单号，进行排序
 //2、判断如果有单号，取出最后一个单号,否则赋值
 //3、用substr方法截取出除了时间后的字符串转为数字
 //4、将该数字自增，转为字符串
 //5、生成单号
  const result = await db.collection('order').field({
    orderNo:true
  }).orderBy('orderNo','asc').get();
  let orderNo = null;
  if(result.errMsg == 'collection.get:ok'){
    if(result.data.length ==0){
      orderNo = 'DC'+ new Date().getTime()+'100';
    }else{
      const len = result.data.length;
      const lastOrderNo = result.data[len-1];// 最大单号
      const num = lastOrderNo.substr(15,3);
      num++;
      orderNo = 'DC'+new Date().getTime()+num;
    }
  }
  return orderNo;
}